package de.hdm_stuttgart.mi.sd1.test.task2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task2.Matrix;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class TestMatrix extends ExaminationTestDefaults {

    @Test
    @Marking(points = 4) public void test_100_constructor() {
        final Matrix m = new Matrix(new int[][]
                {
                        {1, 2, 3},
                        {4, 5, 6},
                        {7, 8, 9}
                });

        Assert.assertEquals(1, m.get(0,0));
        Assert.assertEquals(2, m.get(0,1));
        Assert.assertEquals(3, m.get(0,2));

        Assert.assertEquals(4, m.get(1,0));
        Assert.assertEquals(5, m.get(1,1));
        Assert.assertEquals(6, m.get(1,2));

        Assert.assertEquals(7, m.get(2,0));
        Assert.assertEquals(8, m.get(2,1));
        Assert.assertEquals(9, m.get(2,2));
    }

    @Test(expected = ArithmeticException.class)
    @Marking(points = 6) public void test_200_constructorExceptionMissingRow() {
        new Matrix(new int[][]
                {
                        {1, 2, 3},
                        {4, 5, 6}
                        /* Missing third row*/
                });

    }

    @Test(expected = ArithmeticException.class)
    @Marking(points = 4) public void test_220_constructorExceptionShort() {
        new Matrix(new int[][]
                {
                        {1, 2, 3},
                        {4, 5}, // Too short!
                        {7, 8, 9}
                });
    }

    @Test
    @Marking(points = 2) public void test_120_constructorEqual() {
        final Matrix m1 = new Matrix(new int[][]
                {
                        {1, 2},
                        {3, 4}
                }),

                m2 = new Matrix(new int[][]
                        {
                                {1, 2},
                                {3, 4}
                        });
        Assert.assertEquals(m1, m2);
        Assert.assertEquals(m2, m1);

        final Matrix m3 = new Matrix(new int[][]
                {
                        {1, 2},
                        {3, 9}
                });
        Assert.assertNotEquals(m1, m3);
        Assert.assertNotEquals(m3, m1);
    }

    @Test
    @Marking(points = 2) public void test_300_add() {
        final Matrix
                m1 = new Matrix(new int[][]
                 {
                        {1, 2},
                        {3, 4}
                 }),

                m2 = new Matrix(new int[][]
                 {
                        {5, 6},
                        {7, 8}
                 }),
                sum = new Matrix(new int[][]
                 {
                         {6, 8},
                         {10, 12}
                 });

        Assert.assertEquals(sum, m1.add(m2));
        Assert.assertEquals(sum, m2.add(m1));

        Assert.assertNotEquals(m1, m2);
    }

    @Test(expected = ArithmeticException.class)
    @Marking(points = 2) public void test_320_addException() {
        final Matrix m1 = new Matrix(new int[][]
                {
                        {1, 2, 3},
                        {4, 5, 6},
                        {7, 8, 9}
                }),

                m2 = new Matrix(new int[][]
                        {
                                {5, 6},
                                {7, 8}
                        });
        m1.add(m2);
    }
}
